import { type EditorView, Tooltip } from "@codemirror/view";
import { JsonSchema } from "json-schema-library";
import type { JSONSchema7 } from "json-schema";
import { JSONMode } from "./utils/jsonPointers";
export type CursorData = {
    schema?: JsonSchema;
    pointer: string;
};
export type FoundCursorData = Required<CursorData>;
export type HoverOptions = {
    mode?: JSONMode;
    formatHover?: (data: FoundCursorData) => HTMLElement;
};
/**
 * provides a JSON schema enabled tooltip extension for codemirror
 * @group Codemirror Extensions
 */
export declare function jsonSchemaHover(schema: JSONSchema7, options?: HoverOptions): (view: EditorView, pos: number, side: -1 | 1) => Promise<Tooltip | null>;
export declare class JSONHover {
    private opts?;
    private schema;
    constructor(schema: JSONSchema7, opts?: HoverOptions | undefined);
    getDataForCursor(view: EditorView, pos: number, side: -1 | 1): CursorData | null;
    private formatMessage;
    doHover(view: EditorView, pos: number, side: 1 | -1): Promise<Tooltip | null>;
}
